/*****************************************
 * Small Assignment 2: Processing and Turtle Geometry
 * Name:    Amy Traylor
 * E-mail:  trayloramy@unm.edu
 * Course:      CS591, Computational Fabrication
 * Submitted:    1/31/2022
 *
 * This program includes several different features.
 * To draw a circle with a turtle, press the 0 key.  Press mouse to refresh.
 * To draw a flower, press the 1 key.                Press mouse to refresh number of petals, size, and colors.
 * To plot a polar plot, press the 2 key.            Press mouse to refresh number of indices, size, and colors.
 * To draw a cool turtle path LSystem, press the 3 or 4 key. These take a few seconds to load
 * To see another cool turtle path, press the 5 key. This piece is cumulative, so the best images take 
 a few minutes to appear. The path changes in response to the mouse on both the X and Y axis
 ***********************************************/

import Turtle.*;
Turtle t;
Turtle t2;

float theta, radius;
float x, y;
float amp=300, newAmp =300;
int numPetals = 6;
float flowerSize = 200;
color flowerFill, centerFill;
boolean drawOnce = true;
color[][] ranCol = new color[5][250];
int page=0;

void setup() {
  size(1000, 1000);
  smooth();
  background(255, 255, 0);
  t = new Turtle(this);
  t2 = new Turtle(this);
  t.setX(width/2);
  t.setY(height/2);

  for (int i=0; i<5; i++) {
    for (int c=0; c<250; c++) {
      ranCol[i][c] = color(random(50, 255), random(25, 255), random(150, 255));
      ranCol[4][4] = color(random(0, 100), random(0, 100), random(0, 100));
    }
  }

  turtleDrawing3setup();
  lsystemSetup();
  lsystemSetup2();
}

void draw() {
  switch(page) {
  case 0: 
    turtleCircle(300, 360); 
    break;
  case 1: 
    polarPlot(numPetals); 
    break;
  case 2: 
    drawFlower(); 
    break;
  case 3:  
    drawLSystem(); 
    break;
  case 4: 
    drawLSystem2(); 
    break;
  case 5: 
    drawTurtle3(); 
    break;
  default: 
    turtleCircle(300, 360);
    break;
  }

  surface.setTitle("frameRate: " + frameRate);
}



void keyPressed() {
  //drawOnce=false;
  if(key=='s'){
    saveFrame("compFab-###.png");
  }

  if (key=='0') {
    page=0; 
    mouseCircle(); 
    drawOnce=true;
  }
  if (key=='1') {
    page=1; 
    polarPlotMousePressed(); 
    drawOnce=true;
  }
  if (key=='2') {
    page=2; 
    flowerMousePressed(); 
    drawOnce=true;
  }
  if (key=='3') {
    page=3;  
    drawOnce=true;
  }
  if (key=='4') {
    page=4;  
    drawOnce=true;
  }
  if (key=='5') {
    page=5; 
    background(255);
    //drawOnce=true;
  }
}

void mousePressed() {
  drawOnce=true;

  mouseCircle(); 
  polarPlotMousePressed(); 
  flowerMousePressed(); 


  for (int i=0; i<5; i++) {
    for (int c=0; c<50; c++) {
      ranCol[i][c] = color(random(150, 255), random(125, 255), random(50, 255));
      ranCol[4][4] = color(random(25, 100), random(25, 150), random(25, 150));
    }
  }
}
