float currentFrame = 0;
float rad = 300;
float oldAmp =300;


void polarPlot(float _numPetals) {

  float angle = _numPetals*TWO_PI/360;
  float theta = 0;
  float freq = _numPetals;
  PVector[] pts = new PVector[int(360/_numPetals)+1];

  if (drawOnce==true) {
    float inc = abs(currentFrame-frameCount)/1000;
    println(inc);
    amp = lerp(oldAmp, newAmp, inc);
    if (inc>=1) {
      drawOnce=false;
      inc=0;
      polarPlotMousePressed();
    }
    fill(ranCol[4][4], 20);
    noStroke();
    rect(0, 0, width, height);
    //whole drawing
    pushMatrix();
    translate(width/2, height/2);
    rotate(inc);
    
    for (int i=0; i<pts.length; i++) {
      x = rad * sin(theta);
      y = rad * cos(theta);
      pts[i] = new PVector(x, y);
      noStroke();
      fill(ranCol[1][i]);
      ellipse(x, y, amp/10, amp/10);
      theta+=angle;
      rad = amp*sin(freq*theta);
    }

    if (pts.length>1) {
      for (int p = 1; p<pts.length; p++) {
        beginShape();
        stroke(ranCol[2][p]);
        strokeWeight(1);
        fill(ranCol[3][p]);
        vertex(pts[p].x, pts[p].y);
        vertex(pts[p-1].x, pts[p-1].y);
        endShape();
      }
    }
    popMatrix();
  }

}

void polarPlotMousePressed() {
  newAmp = random(300, 500);
  numPetals = int(random(2, 15));
  currentFrame = frameCount;
  oldAmp = amp;
}
